MODULE PZO_CALC

  IMPLICIT NONE

CONTAINS

   SUBROUTINE PZOISO(POTSP,POTPZ)
        Use Input_Data
     IMPLICIT NONE
     REAL, INTENT(  OUT) :: POTSP,POTPZ

     REAL :: DPZ_1,DPZ_S

     !!! COMMON
     REAL :: RHO,ZETA,ETA
     COMMON /QAGON/RHO,ZETA,ETA

     ETA=1.E0
     CALL PREST(PZ_1=DPZ_1,PZ_S=DPZ_S)

     POTSP=CPZ*CSP*RC*DPZ_1
     POTPZ=CPZ*RC*((CPZ_Q1+CPZ_Q2/2.E0)*DPZ_1+CPZ_Q2*DPZ_S)
 
     RETURN
     
   END SUBROUTINE PZOISO

   SUBROUTINE PZOANISO(POTSP,POTPZ)
        Use Input_Data
     IMPLICIT NONE
     REAL, INTENT(  OUT) :: POTSP,POTPZ

     REAL :: DPZ_1,DPZ_ETA1,DPZ_ETA2

     !!! COMMON
     REAL :: RHO,ZETA,ETA
     COMMON /QAGON/RHO,ZETA,ETA

     ETA=1.E0
     CALL PREST(PZ_1=DPZ_1,PZ_ETA1=DPZ_ETA1,PZ_ETA2=DPZ_ETA2)

     POTSP=CPZ*CSP*RC*DPZ_1
     POTPZ=CPZ*RC*( CI1*DPZ_1 +&
                        CI2*( CNP31_1*DPZ_ETA2 - CNP31_2*DPZ_ETA1 )/ETA_DIF +&
                        CI3/((1.E0-ETA1)*(1.E0-ETA2)) *&
                            ( (CNE_2-CNE_1)*DPZ_1 +&
                              (CNE2_1*DPZ_ETA2 - CNE2_2*DPZ_ETA1)/ETA_DIF ) ) 
     RETURN
     
   END SUBROUTINE PZOANISO

   SUBROUTINE PREST(PZ_1,PZ_S,PZ_ETA1,PZ_ETA2)

      Use Input_Data, ONLY: RD,RC,ZC,ETA1,ETA2
   
   IMPLICIT NONE

!! 'dummy' and local variables !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 

   REAL PZ_1
   REAL,OPTIONAL :: PZ_S,PZ_ETA1,PZ_ETA2

   DOUBLE PRECISION DPZ_1,DPZ_S,DPZ_ETA1,DPZ_ETA2
!! GAG Variables  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 

   INTEGER, PARAMETER :: LIMITE=100
   DOUBLE PRECISION AL,AU,ABSERR,EPSABS,EPSREL,WORK(4*LIMITE),RO,ZE
   INTEGER IER,IWORK(LIMITE),KEY,LAST,LENW,LIMIT,NEVAL

   DOUBLE PRECISION, EXTERNAL :: I_FI00,I_FDA00

   !!! COMMON
   REAL :: RHO,ZETA,ETA
   COMMON /QAGON/RHO,ZETA,ETA

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
   DOUBLE PRECISION RHOP
   
    RO=RHO
    ZE=ZETA
    AL=0.D0
    AU=DBLE(RD)

    EPSABS=0.D0
    EPSREL=1.D-4
    KEY=6
    LIMIT=LIMITE
    LENW=LIMIT*4

!   WRITE(6,*)RHO*RC,ZETA*ZC
!   ETA=1.E0
!   DO IER=1,1000
!    RHOP=DBLE(IER-1)*RD/DBLE(999)
!    WRITE(55,'(10(E15.8,1X))')RHOP*RC,I_FDA00(RHOP)
!   END DO
!   STOP
    
    ETA=1.E0
    CALL DQAG(I_FI00,AL,AU,EPSABS,EPSREL,KEY,DPZ_1,ABSERR,NEVAL, &
             IER,LIMIT,LENW,LAST,IWORK,WORK)
    IF (IER.NE.0) &
       CALL DQAG_CHECK("FI00","PZ_1",DPZ_1,ABSERR,RO*RC,ZE*ZC,NEVAL,IER,LAST)
     
    PZ_1=REAL(DPZ_1) 
    IF(PRESENT(PZ_S)) THEN
        ETA=1.E0
        CALL DQAG(I_FDA00,AL,AU,EPSABS,EPSREL,KEY,DPZ_S,ABSERR,NEVAL, &
                 IER,LIMIT,LENW,LAST,IWORK,WORK)
        IF (IER.NE.0) &
           CALL DQAG_CHECK("FDA00","PZ_S",DPZ_S,ABSERR,RO*RC,ZE*ZC,NEVAL,IER,LAST)
         
        PZ_S=REAL(DPZ_S)  
    END IF
    IF(PRESENT(PZ_ETA1).AND.PRESENT(PZ_ETA2)) THEN
        ETA=ETA1
        CALL DQAG(I_FI00,AL,AU,EPSABS,EPSREL,KEY,DPZ_ETA1,ABSERR,NEVAL, &
                 IER,LIMIT,LENW,LAST,IWORK,WORK)
        IF (IER.NE.0) &
           CALL DQAG_CHECK("FI00","PZ_ETA1",DPZ_ETA1,ABSERR,RO*RC,ZE*ZC,NEVAL,IER,LAST)
         
        ETA=ETA2
        CALL DQAG(I_FI00,AL,AU,EPSABS,EPSREL,KEY,DPZ_ETA2,ABSERR,NEVAL, &
                 IER,LIMIT,LENW,LAST,IWORK,WORK)
        IF (IER.NE.0) &
           CALL DQAG_CHECK("FI00","PZ_ETA2",DPZ_ETA2,ABSERR,RO*RC,ZE*ZC,NEVAL,IER,LAST)
        PZ_ETA1=REAL(DPZ_ETA1); PZ_ETA2=REAL(DPZ_ETA2)
    END IF

   RETURN
   END SUBROUTINE PREST

   SUBROUTINE DQAG_CHECK(FUNC,RESNAME,RES,ABSERR,RO,ZE,NEVAL,IER,LAST)
   IMPLICIT NONE
   CHARACTER(LEN=*)    :: FUNC,RESNAME
   DOUBLE PRECISION    :: RES,ABSERR,RO,ZE
   INTEGER             :: NEVAL,IER,LAST
     WRITE(6,*)"ERROR AT: RHO: ",RO," ZETA: ",ZE
     WRITE(6,*)"QAG ",TRIM(FUNC)," ",TRIM(RESNAME)," RESULT=",RES
     WRITE(6,*)"QAG ABSERR=",ABSERR
     WRITE(6,*)"QAG NEVAL=",NEVAL
     WRITE(6,*)"QAG IER=",IER
     WRITE(6,*)"QAG LAST=",LAST

     RETURN
   END SUBROUTINE DQAG_CHECK

  FUNCTION FI00(RHO,ZETA,RHOP,ZM,ETA) RESULT(I00)
        Use Input_Data, ONLY: RC,ZC
        Use ELIPT_MOD

    IMPLICIT NONE
    DOUBLE PRECISION, INTENT(IN) :: RHO,ZETA,RHOP,ZM,ETA
    DOUBLE PRECISION :: I00

    DOUBLE PRECISION ::  PI,DPI
    DOUBLE PRECISION :: DELTAM,DELTA0,&
                        KM,K0,CKM,CK0,KKM,KK0

      
      PI  = DATAN(1.D0)*4.D0
      DPI = 2.D0*PI

      DELTAM = SQRT(ETA)*DABS(ZETA-ZM)*ZC/RC
      DELTA0 = SQRT(ETA)*DABS(ZETA)*ZC/RC

      IF(RHO.EQ.0.D0) THEN
       I00=(1.D0/DSQRT(DELTAM**2+RHOP**2)) - &
           (1.D0/DSQRT(DELTA0**2+RHOP**2))
       I00 = I00/2.D0
       RETURN
      END IF

      KM = 2.D0*DSQRT( RHO*RHOP/((RHO+RHOP)**2+DELTAM**2) )
      K0 = 2.D0*DSQRT( RHO*RHOP/((RHO+RHOP)**2+DELTA0**2) ) 

      CKM = (1.D0-KM**2)
      CK0 = (1.D0-K0**2)      

      CALL ELIPTK0(KM,KKM)
      CALL ELIPTK0(K0,KK0)

!!!!! I00 expressed in terms of RHO,RHOP,DELTA !!!!!!!!!!!!!!!!!!!
 
      I00 = 2.D0/PI*(1.D0/DSQRT(DELTAM**2+(RHO+RHOP)**2)*KKM - &
           1.D0/DSQRT(DELTA0**2+(RHO+RHOP)**2)*KK0)

      I00=I00/2.D0


      RETURN

  
  END FUNCTION FI00

  FUNCTION FDA00(RHO,ZETA,RHOP,ZM,ETA) RESULT(DA00)
        Use Input_Data, ONLY: RC,ZC
        Use ELIPT_MOD

    IMPLICIT NONE
    DOUBLE PRECISION, INTENT(IN) :: RHO,ZETA,RHOP,ZM,ETA
    DOUBLE PRECISION :: DA00

    DOUBLE PRECISION ::  PI,DPI
    DOUBLE PRECISION :: SRRHOP,RRHOP15,DELTAM,DELTA0,&
                        KM,K0,CKM,CK0,KKM,KK0,EKM,EK0

      PI  = DATAN(1.D0)*4.D0
      DPI = 2.D0*PI

      SRRHOP=SQRT(RHO*RHOP)
      RRHOP15=SQRT(RHO*RHOP)**3

      DELTAM = DSQRT(ETA)*DABS(ZETA-ZM)*ZC/RC
      DELTA0 = DSQRT(ETA)*DABS(ZETA)*ZC/RC

      KM = 2.D0*DSQRT( RHO*RHOP/((RHO+RHOP)**2+DELTAM**2) )
      K0 = 2.D0*DSQRT( RHO*RHOP/((RHO+RHOP)**2+DELTA0**2) ) 

      CKM = (1.D0-KM**2)
      CK0 = (1.D0-K0**2)      

      CALL ELIPT0(KM,KKM,EKM)
      CALL ELIPT0(K0,KK0,EK0)

       IF (RHO .EQ. 0.D0) THEN
          DA00 = ( DELTAM**2/SQRT(RHOP**2+DELTAM**2)**3) &
               -(DELTA0**2/SQRT(RHOP**2+DELTA0**2)**3 )
          DA00 = DA00/4.D0
          RETURN
       END IF

      DA00 = DELTAM**2*KM**3/(2.D0*DPI*CKM*RRHOP15)*EKM &
            -DELTA0**2*K0**3/(2.D0*DPI*CK0*RRHOP15)*EK0 

      DA00 = DA00/4.D0   

      RETURN

  END FUNCTION FDA00


END MODULE PZO_CALC
